标签:des style blog http color os io strong for
https://oj.leetcode.com/problems/edit-distance/
Edit Distance
Given two words word1 and word2, find the minimum number of steps required to convert word1 to word2. (each operation is counted as 1 step.)
You have the following 3 operations permitted on a word:
a) Insert a character
b) Delete a character
c) Replace a character
1 class Solution: 2 # @return an integer 3 def minDistance(self, word1, word2): 4 #http://www.cnblogs.com/zuoyuan/p/3773134.html 5 m=len(word1)+1; n=len(word2)+1 6 dp = [[0 for i in range(n)] for j in range(m)] 7 delCost = insCost = subCost = 1 # The cost for each operation 8 9 for i in range(m): 10 dp[i][0]=i 11 for j in range(n): 12 dp[0][j]=j 13 14 for i in range(1,m): 15 for j in range(1,n): 16 # del insert same sub 17 #dp[i][j]=min(dp[i-1][j]+1, dp[i][j-1]+1, dp[i-1][j-1]+(0 if word1[i-1]==word2[j-1] else 1)) 18 dp[i][j]=min(dp[i-1][j] + insCost, dp[i][j-1] + delCost, dp[i-1][j-1]+(0 if word1[i-1]==word2[j-1] else subCost)) 19 return dp[m-1][n-1] 20 21 """ 22 解题思路:这道题是很有名的编辑距离问题。用动态规划来解决。 23 状态转移方程是这样的:dp[i][j]表示word1[0...i-1]到word2[0...j-1]的编辑距离。 24 而dp[i][0]显然等于i,因为只需要做i次删除操作就可以了。 25 同理dp[0][i]也是如此,等于i,因为只需做i次插入操作就可以了。 26 dp[i-1][j]变到dp[i][j]需要加1,因为word1[0...i-2]到word2[0...j-1]的距离是dp[i-1][j], 27 而word1[0...i-1]到word1[0...i-2]需要执行一次删除,所以dp[i][j]=dp[i-1][j]+1; 28 同理dp[i][j]=dp[i][j-1]+1,因为还需要加一次word2的插入操作。 29 如果word[i-1]==word[j-1],则dp[i][j]=dp[i-1][j-1], 30 如果word[i-1]!=word[j-1],那么需要执行一次替换replace操作,所以dp[i][j]=dp[i-1][j-1]+1,以上就是状态转移方程的推导。 31 """ 32 ‘‘‘ Implement the minimum edit distance according to 33 the description of WikiPedia: 34 http://en.wikipedia.org/wiki/Edit_distance 35 Some other implements are available here: 36 http://en.wikibooks.org/wiki/Algorithm_Implementation/Strings/Levenshtein_distance 37 ‘‘‘ 38 #if len(word1) < len(word2): 39 # word1, word2 =word2, word1 40 """ 41 delCost = insCost = subCost = 1 # The cost for each operation 42 steps = range(len(word1)+1) 43 44 for word2Index in xrange(len(word2)): 45 diag = steps[0] # d(i-1, j-1) 46 steps[0] += 1 47 48 for word1Index in xrange(len(word1)): 49 temp = steps[word1Index+1] # d(i-1, j) 50 51 if word1[word1Index] == word2[word2Index]: 52 steps[word1Index+1] = diag 53 else: 54 steps[word1Index+1] = min(steps[word1Index+1] + insCost, 55 steps[word1Index] + delCost, 56 diag + subCost) 57 58 diag = temp # Store d(i-1, j-1) for next cell 59 60 return steps[-1] 61 """
Edit Distance (or Levenshtein Distance) python solution for leetcode EPI 17.2
标签:des style blog http color os io strong for
原文地址:http://www.cnblogs.com/asrman/p/3930675.html